Top 10 open source projects of 2014
================================================================================
![](http://opensource.com/sites/default/files/styles/image-full-size/public/images/life/top10_projects_lead.jpg?itok=tMZo2sYi)

Image credits : [CC0 Public Domain][1], modifications by Jen Wike Huger

Every year we collect the best of the best open source projects covered on Opensource.com. [Last year's list of 10 projects][2] guided people working and interested in tech throughout 2014. Now, we're setting you up for 2015 with a brand new list of accomplished open source projects.

Some faces are new. Some have been around and just keep rocking it. Let's dive in!

## Top 10 open source projects in 2014 ##

### Docker ###

[application container platform][3]

"In the same way that power management and virtualisation has allowed us to get maximum engineering benefit from our server utilisation, the problem of how to really solve first world problems in virtualisation has remained prevalent. Docker's open sourcing in 2013 can really align itself with these pivotal moments in the evolution of open source—providing the extensible building blocks allowing us as engineers and architects to extend distributed platforms like never before." —Richard Morrell, [Senior software engineer Petazzoni on the breathtaking growth of Docker][4].

**Interview**: VP of Services for Docker talks to Jodi Biddle in [Why is Docker the new craze in virtualization and cloud computing?][5] "I think it's the lightweight nature of Docker combined with the workflow. It's fast, easy to use and a developer-centric DevOps-ish tool. Its mission is basically: make it easy to package and ship code." —James Turnbull.

### Kubernetes ###

[orchestration system for containers][6]

"One of the projects you're starting to hear a lot about in the orchestration space is [Kubernetes][7], which came out of Google's internal container work. It aims to provide features such as high availability and replication, service discovery, and service aggregation." —Gordon Haff, [Open source accelerating the pace of software][8].

### Taiga ###

[project management platform][9]

"It’s almost always the case that the project management tool doesn’t reflect the actual project scenario. One solution to this is using a tool that is intuitive and fits alongside the developer's normal workflow. Additionally, a tool that is quick to update and attracts users to use it. [Taiga][10] is an open source project management tool that aims to solve the basic problem of software usability." —Nitish Tiwari, [Taiga, a new open source project management tool with focus on usability][11].

### Apache Mesos ###

[cluster manager][12]

"[Apache Mesos][13] is a cluster manager that provides efficient resource isolation and sharing across distributed applications or frameworks. It sits between the application layer and the operating system and makes it easier to deploy and manage applications in large-scale clustered environments more efficiently. It can run many applications on a dynamically shared pool of nodes. Prominent users of Mesos include Twitter, Airbnb, MediaCrossing, Xogito and Categorize. —Sachin P Bappalige, [Open source datacenter computing with Apache Mesos][14].

Interview: Head of Open Source at Twitter talks to Jason Hibbets in [Scale like Twitter with Apache Mesos][15]. "As of today, Twitter has over 270 million active users which produces 500+ million tweets a day, up to 150k+ tweets per second, and more than 100TB+ of compressed data per day. Architecturally, Twitter is mostly composed of services, mostly written in the open source project [Finagle][16], representing the core nouns of the platform such as the user service, timeline service, and so on. Mesos allows theses services to scale to tens of thousands of bare-metal machines and leverage a shared pool of servers across data centers." —Chris Aniszczyk

### OpenStack ###

[cloud computing platform][17]

"As OpenStack continues to mature and slowly make its way into production environments, the focus on the user is continuing to grow. And so, to better meet the needs of users, the community is working hard to get users to meet the next step of engagement by highlighting those users who are change agents both in their organization and within the OpenStack community at large: the superusers." —Jason Baker, [What is an OpenStack superuser][18]?

**Interview**: Infrastructure manager at CERN talks to Jason Hibbets in [How OpenStack powers the research at CERN][19]. "At CERN, the European Organization for Nuclear Research physicists and engineers are probing the fundamental structure of the universe. In order to do this, we use some of the world's largest and most complex scientific instruments such as the Large Hadron Collider, a 27 KM ring 100m underground on the border between France and Switzerland. OpenStack provides the infrastructure cloud which is used to provide much of the compute resources for this processing." —Tim Bell.

### Ansible ###

[IT automation tool][20]

"A lot of what I want to do is enable people to not only have more free time for beer, but to have more free time for their own projects, their own ideas, and to do new an interesting things." —[Michael DeHaan, Making your IT infrastructure boring with Ansible][21].

**Interview**: CTO of Ansible talks to Jen Krieger in [Behind the scenes with CTO Michael DeHaan of Ansible][22]. "I like to quote Star Trek 2 a lot. We definitely optimize for 'the needs of the many'. I know Spock dies after he says that, but he does get to come back." —Michael DeHaan

### ownCloud ###

[cloud storage tool][23]

"I was looking for an easy way how to have all my online storage services, such as Google Drive and Dropbox, integrated with my Linux desktop without using some nasty hack, and I finally have a solution that works. I'm here to share it with you. This is not rocket science really, all I did was a little bit of documentation reading, and a couple of clicks." —Jiri Folta, [Using ownCloud to integrate Dropbox, Google Drive, and more in Gnome][24].

**Listed**: Top 5 open source alternatives: "ownCloud does most everything that the proprietary names do and it keeps control of your information in your hands." —Scott Nesbitt, [Five open source alternatives to popular web apps][25].

### Apache Hadoop ###

[framework for big data][26]

"Apache Hadoop is an open source software framework for storage and large scale processing of data-sets on clusters of commodity hardware. Hadoop is an Apache top-level project being built and used by a global community of contributors and users. It is licensed under the Apache License 2.0." —Sachin P Bappalige, [An introduction to Apache Hadoop for big data][27].

### Drupal ###

[content management system (CMS)][28]

"When it was released in 2011, Drupal 7 was the most accessible open source content management system (CMS) available. I expect that this will be true until the release of Drupal 8. Web accessibility requires constant vigilance and will be something that will always need attention in any piece of software striving to meet the Web Content Accessibility Guidelines (WCAG) 2.0 guidelines." —Mike Gifford, [Drupal 8's accessibility advantage][29].

### OpenDaylight ###

[foundation for software defined networking][30]

"We are seeing more and more that the networking functions traditionally done in the datacenter by dedicated, almost exclusively proprietary hardware and software combinations, are now being defined through software. Leading that charge within the open source community has been the [OpenDaylight Project][31], a collaborative project through the [Linux Foundation][32] working to define the needs which software defined networking may fill and coordinating the efforts of individuals and companies worldwide to create an open source solution to software defined networking (SDN)." —Jason Baker, [Define your network in software with OpenDaylight][33].

--------------------------------------------------------------------------------

via: http://opensource.com/business/14/12/top-10-open-source-projects-2014

作者：[Jen Wike Huger][a]
译者：[译者ID](https://github.com/译者ID)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出

[a]:http://opensource.com/users/jen-wike
[1]:http://pixabay.com/en/lightbulb-lamp-light-hotspot-336193/
[2]:http://opensource.com/life/13/12/top-open-source-projects-2013
[3]:https://www.docker.com/
[4]:http://opensource.com/business/14/7/interview-jerome-petazzoni-docker
[5]:https://opensource.com/business/14/7/why-docker-new-craze-virtualization-and-cloud-computing
[6]:http://kubernetes.io/
[7]:https://cloud.google.com/compute/docs/containers
[8]:http://opensource.com/business/14/11/open-source-accelerating-pace-software
[9]:https://taiga.io/
[10]:https://github.com/taigaio
[11]:https://opensource.com/business/14/10/taiga-open-source-project-management-tool
[12]:http://mesos.apache.org/
[13]:http://mesos.apache.org/
[14]:https://opensource.com/business/14/9/open-source-datacenter-computing-apache-mesos
[15]:https://opensource.com/business/14/8/interview-chris-aniszczyk-twitter-apache-mesos
[16]:https://twitter.github.io/finagle/
[17]:http://www.openstack.org/
[18]:https://opensource.com/business/14/5/what-is-openstack-superuser
[19]:https://opensource.com/business/14/10/interview-tim-bell-cern-it-operating-systems
[20]:http://www.ansible.com/home
[21]:https://opensource.com/business/14/12/ansible-it-infrastructure
[22]:https://opensource.com/business/14/10/interview-michael-dehaan-ansible
[23]:http://owncloud.org/
[24]:https://opensource.com/life/14/12/using-owncloud-integrate-dropbox-google-drive-gnome
[25]:https://opensource.com/life/14/10/five-open-source-alternatives-popular-web-apps
[26]:http://hadoop.apache.org/
[27]:http://opensource.com/life/14/8/intro-apache-hadoop-big-data
[28]:https://www.drupal.org/
[29]:http://opensource.com/business/14/5/new-release-drupal-8-accessibility-advantage
[30]:http://www.opendaylight.org/
[31]:http://www.opendaylight.org/
[32]:http://www.linuxfoundation.org/
[33]:http://opensource.com/business/14/5/defining-your-network-software-opendaylight
